#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include "Environment.hpp"

// AMDiS includes
#include <amdis/Initfile.hpp>
#include <amdis/Output.hpp>

namespace AMDiS
{
  Environment::Environment(std::string const& initFileName)
  {
    Parameters::clearData();
    if (!initFileName.empty())
      Parameters::init(initFileName);
  }

  Environment::Environment(int& argc, char**& argv, std::string const& initFileName)
    : Environment(initFileName)
  {
    auto& helper = Dune::MPIHelper::instance(argc, argv);

    auto& mpi = Mpi::instance();
    mpi.registerMpiHelper(helper);

    Parameters::clearData();
    if (initFileName.empty()) {
      if (argc > 1)
        Parameters::init(argv[1]);
      else
        warning("No initfile specified. Using default values for all parameters.");
    }
  }

} // end namespace AMDiS
